#include "test_register_function.h"

#include <iostream>

/// Creates an instance if not already created
TestManager& TestManager::getInstance()
{
  static TestManager instance;
  return instance;
}

TestManager::TestManager()
  :tree(new TestComposite("All Tests"))
{
}

void TestManager::registerFunctions(const QString& name, TestFunctionStruct* f)
{
  tree->addTest(name.split(':'), f);
}

TestFunctionStruct* TestManager::getTestFunctionStructFromQStringList(QStringList path)
{
  TestFunctionStruct* testStruct = TestManager::getInstance().getRoot();

  while(!path.empty())
  {
    testStruct = testStruct->getLeaves()[path[0]];
    path.pop_front();
  }
  return testStruct;
}
